#!/bin/bash
echo -e "\e[1m© Victor Dobrov экспертный профиль krusader: коды кнопок, ассоциации, перевод…\e[0m\n"

isroot(){ [ $UID -eq 0 -o -r /proc/kcore -o -w /etc ];} # запуск от админа?
isterm(){ ps -o stat= -p $$ | grep -q \+;} # консоль доступна? иначе запуск из графической среды
exiter(){ set -- "${1:-запустите скрипт от администратора!}" "${2:-Сбой настройки профиля}" ${@:3}
	isterm && echo -e "\e[41m $1 \e[0m" || notify-send -t 19999 -u critical "$2" "$1"; exit
}
aptpkg(){ for pkg in "$@"; do # ошибка ? ставим из ./pkg/имя
		dpkg-query --show $pkg &>/dev/null || apt -y install $pkg
		which $pkg &>/dev/null || apt-get -y install ./pkg/$pkg*.deb 2>/dev/null; # вместо -y рекомендуется --assume-no
	done
}
esc(){ sed 's/\([\$|\^|\{|\[|\(|\||\)|\+|\?|\/|\\|\.|\*]\)/\\\1/g' <<<$@;}
stat_users(){ # [-r] /home[/DOMAIN] хомяк, ID юзера, ID группы
	local users recurse; [[ $1 = -r ]] && { recurse=1; shift;}; cd ${1:-/home}
	users=$(LC_ALL=C stat -t -c '%n %u %g %F' ./* | grep -vnwE "[[:upper:]]+|*found" 2>/dev/null | \
		sed "/directory/!d;s/^[0-9]*:\./$(esc ${1:-/home})/;s/ directory//") # хомяк, ID юзера, ID группы
	(($recurse)) || while read u; do
		users="$users\n$(stat_users -r $u)"
	done <<< $(stat -c %n -t /home/* | grep -wE "[[:upper:]]+") # только домены
	printf "$users"
}
cp_user(){ # source home uid gid; копировать source в хомяк юзера, сменив владельца, группу, права
	[[ -d $1 && -n $3 ]] || return;
	chown -R $3:${4:-$(grep video /etc/group|cut -d: -f3)} $1 2>/dev/null
	chmod -R 755 $1; find $1 -type f -exec chmod 644 {} \;
	cp -Ra "$1"/. $2
}
isroot || exiter # не админ

# добавить имя хоста в случае ошибки: sudo: unable to resolve host … В соединении отказано
grep -q $(hostname) /etc/hosts || { echo 127.0.1.1 $(hostname).rosgvard.ru $(hostname) | tee -a /etc/hosts && echo "имя компютера добавлено в /etc/hosts";}

aptpkg conky-std krusader libkf5kiogui5 keditbookmarks # +поиск из ./pkg
which krusader &>/dev/null || exiter "Ошибка! Krusader не установлен! Возможно система не обновлена, имеет сбои или недоступна сеть.\n Установите krusader из Synaptic или консоли, затем снова запустите скрипт…"

cp -r ./system/* / # обновить системные файлы, default-профиль, исправить ошибки пакета krusader
cp -r ./system/etc/skel /tmp # конфиги по-умолчанию
while read i; do u=($i) # добавим конфиги входившим в графический сеанс
	[[ -f $u/.Xauthority ]] && cp_user /tmp/skel $i # прочие обновятся при первом входе из /etc/skel
done <<<$(stat_users)

echo -e "\e[44m Установлены проводник Krusader и монитор системы Conky \n Для всех пользователей (и новых) создаются рекомендуемые настройки.\n В автозапуске отключайте «Krusader по-умолчанию», если желаете \n использовать другой проводник. «Conky» отключается там же.\e[0m"